CON
        _clkmode = xtal1 + pll16x
        _xinfreq = 5_000_000
        MHZ = 80 
VAR
Long Pin[6] 
Long Cog
OBJ

PUB Start : Status
    if not Cog
      repeat Status from 1 to 5
        Pin[status] := Mhz * 1500                        ' Center Pins[0..5]
      Pin[0] := MHz * 1000                               ' Zero throttle pin
    Status := Cog := cognew(@RC_Recieve, @Pin) + 1       ' Launch new cog 

Pub GetuS(_Pin): Value
    Value := Pin[_Pin]
    Value /= MHZ
Pub GetRC(_Pin): Value
    Value := Pin[_Pin]
    Value /= MHZ
    Value -= 1500
DAT
        org   0

RC_Recieve

:INIT
        mov        Address, PAR                            'Puts address pointer into Address Variable.
        andn          DIRA, Pin_Mask                       'Sets DIRA register to inputs according to Pin_Mask value. 
                                                        
:LOOP
        mov    PrevPinStat, NewPinStat
        waitpne NewPinStat, Pin_Mask 
        mov     NewPinStat, INA                            
        mov        Counter, CNT                                                     
        and     NewPinStat, Pin_Mask                       

        ' Mask for POS edge changes
        mov      PosEdStat, NewPinStat
        andn     PosEdStat, PrevPinStat

        ' Mask for NEG edge changes
        andn   PrevPinStat, NewPinStat

:POS
        tjz      PosEdStat, #:NEG                          ' Skip if no POS edge changes
'Pin 0
        test     PosEdStat, Pin_Mask_0    wz              ' Change on pin?
if_nz   mov       PosEdge0, Counter                           ' Store POS edge change cnt
'Pin 1
        test     PosEdStat, Pin_Mask_1    wz              ' ...
if_nz   mov       PosEdge1, Counter
'Pin 2
        test     PosEdStat, Pin_Mask_2    wz              ' Change on pin?
if_nz   mov       PosEdge2, Counter
'Pin 3
        test     PosEdStat, Pin_Mask_3    wz              ' Change on pin?
if_nz   mov       PosEdge3, Counter
'Pin 4
        test     PosEdStat, Pin_Mask_4    wz              ' Change on pin?
if_nz   mov       PosEdge4, Counter
'Pin 5
        test     PosEdStat, Pin_Mask_5    wz              ' Change on pin?
if_nz   mov       PosEdge5, Counter

:NEG
        tjz    PrevPinStat, #:loop                        ' Skip if no NEG edge changes
'Pin 0
        mov        Address, par                           ' Get data pointer
        test   PrevPinStat, Pin_Mask_0    wz              ' Change on pin 0?
if_nz   mov        NegEdge, Counter                       ' Get NEG edge change cnt
if_nz   sub        NegEdge, PosEdge0                      ' Get pulse width
if_nz   wrlong     NegEdge, Address                       ' Store pulse width
'Pin 1
        add        Address, #4                            ' Get next data pointer
        test   PrevPinStat, Pin_Mask_1    wz              ' ...
if_nz   mov        NegEdge, Counter              
if_nz   sub        NegEdge, PosEdge1             
if_nz   wrlong     NegEdge, Address
'Pin 2
        add        Address, #4                            ' Get next data pointer
        test   PrevPinStat, Pin_Mask_2    wz              ' ...
if_nz   mov        NegEdge, Counter              
if_nz   sub        NegEdge, PosEdge2             
if_nz   wrlong     NegEdge, Address
'Pin 3
        add        Address, #4                            ' Get next data pointer
        test   PrevPinStat, Pin_Mask_3    wz              ' ...
if_nz   mov        NegEdge, Counter              
if_nz   sub        NegEdge, PosEdge3             
if_nz   wrlong     NegEdge, Address
'Pin 4
        add        Address, #4                            ' Get next data pointer
        test   PrevPinStat, Pin_Mask_4    wz              ' ...
if_nz   mov        NegEdge, Counter              
if_nz   sub        NegEdge, PosEdge4             
if_nz   wrlong     NegEdge, Address
'Pin 5
        add        Address, #4                            ' Get next data pointer
        test   PrevPinStat, Pin_Mask_5    wz              ' ...
if_nz   mov        NegEdge, Counter              
if_nz   sub        NegEdge, PosEdge5             
if_nz   wrlong     NegEdge, Address
        
jmp   #:LOOP


Pin_Mask         Long %0000_0000_0011_1111_0000_0000_0000_0000
Address          Long %0000_0000_0000_0000_0000_0000_0000_0000    'Pointer Address value.
PrevPinStat      Long %0000_0000_0000_0000_0000_0000_0000_0000    'Prevous Input Pin State
NewPinStat       Long %0000_0000_0000_0000_0000_0000_0000_0000    'Current Input Pin State
Counter          Long %0000_0000_0000_0000_0000_0000_0000_0000
PosEdStat        Long %0000_0000_0000_0000_0000_0000_0000_0000    'Positive Edge Status storage variable for masking.

PosEdge0         Long %0000_0000_0000_0000_0000_0000_0000_0000
PosEdge1         Long %0000_0000_0000_0000_0000_0000_0000_0000
PosEdge2         Long %0000_0000_0000_0000_0000_0000_0000_0000
PosEdge3         Long %0000_0000_0000_0000_0000_0000_0000_0000
PosEdge4         Long %0000_0000_0000_0000_0000_0000_0000_0000
PosEdge5         Long %0000_0000_0000_0000_0000_0000_0000_0000
PosEdge6         Long %0000_0000_0000_0000_0000_0000_0000_0000
PosEdge7         Long %0000_0000_0000_0000_0000_0000_0000_0000

NegEdge          Long %0000_0000_0000_0000_0000_0000_0000_0000

Pin_Mask_0       Long %0000_0000_0000_0001_0000_0000_0000_0000
Pin_Mask_1       Long %0000_0000_0000_0010_0000_0000_0000_0000
Pin_Mask_2       Long %0000_0000_0000_0100_0000_0000_0000_0000
Pin_Mask_3       Long %0000_0000_0000_1000_0000_0000_0000_0000
Pin_Mask_4       Long %0000_0000_0001_0000_0000_0000_0000_0000
Pin_Mask_5       Long %0000_0000_0010_0000_0000_0000_0000_0000
Pin_Mask_6       Long %0000_0000_0100_0000_0000_0000_0000_0000
Pin_Mask_7       Long %0000_0000_1000_0000_0000_0000_0000_0000
fit 496